SystemOrganization addCategory: #'Pier-Gallery'!
SystemOrganization addCategory: #'Pier-Gallery-Model'!
SystemOrganization addCategory: #'Pier-Gallery-Seaside'!

!PRStructure methodsFor: '*pier-gallery-model-testing' stamp: 'damiencassou 11/18/2008 13:18'!
isGallery
	^ false! !

!PRStructure methodsFor: '*pier-gallery-model-testing' stamp: 'damiencassou 11/18/2008 13:18'!
isPicture
	^ false! !

!PRVisitor methodsFor: '*pier-gallery-model-visiting-structure' stamp: 'damiencassou 11/18/2008 13:27'!
visitGallery: aGallery
	self visitCase: aGallery! !

!PRVisitor methodsFor: '*pier-gallery-model-visiting-structure' stamp: 'damiencassou 11/18/2008 16:23'!
visitPicture: aPicture
	self visitCase: aPicture! !

PRCase subclass: #PGGallery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Model'!

!PGGallery class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:40'!
canBeParentOf: aStructureClass
	^ aStructureClass includesBehavior: PGPicture ! !

!PGGallery class methodsFor: 'accessing-description' stamp: 'damiencassou 11/18/2008 13:24'!
descriptionDocument
	^ super descriptionDocument
		label: 'Description';
		yourself! !

!PGGallery class methodsFor: 'accessing-description' stamp: 'damiencassou 11/18/2008 13:31'!
descriptionTitle
	^ super descriptionTitle
		comment: 'Title of the gallery';
		yourself! !

!PGGallery class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:24'!
isAbstract
	^ false! !

!PGGallery methodsFor: 'visitor accepting' stamp: 'damiencassou 11/18/2008 13:26'!
accept: aVisitor
	aVisitor visitGallery: self! !

!PGGallery methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/18/2008 13:20'!
allPicturesIn: aContext
	^ (aContext enumeratorFor: self)
		select: [:child | child isPicture]! !

!PGGallery methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:18'!
isGallery
	^ true! !

!PGGallery methodsFor: '*pier-gallery-seaside' stamp: 'damiencassou 11/18/2008 13:46'!
viewComponentClass
	^ PGGalleryHtmlView ! !

PRCase subclass: #PGPicture
	instanceVariableNames: 'fileStructure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Model'!

!PGPicture class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:39'!
canBeChildOf: aClass
	^ aClass includesBehavior: PGGallery ! !

!PGPicture class methodsFor: 'accessing-description' stamp: 'damiencassou 11/18/2008 13:33'!
descriptionDocument
	^ super descriptionDocument
		label: 'Description';
		yourself! !

!PGPicture class methodsFor: 'accessing-description' stamp: 'damiencassou 11/19/2008 13:39'!
descriptionFile
	^ PRFile descriptionFile
		addCondition: [:file | file isImage] labelled: 'Only pictures can be added to a gallery'! !

!PGPicture class methodsFor: 'accessing-description' stamp: 'damiencassou 11/18/2008 13:32'!
descriptionTitle
	^ super descriptionTitle 
		comment: 'Title of the picture';
		yourself! !

!PGPicture class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:41'!
isAbstract
	^ false! !

!PGPicture methodsFor: 'visitor accepting' stamp: 'damiencassou 11/18/2008 13:28'!
accept: aVisitor
	aVisitor visitPicture: self! !

!PGPicture methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/19/2008 13:36'!
file
	^ self fileStructure file! !

!PGPicture methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/19/2008 13:36'!
file: aFile
	^ self fileStructure file: aFile! !

!PGPicture methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/19/2008 14:08'!
fileStructure
	^ fileStructure ifNil: [fileStructure := PRFile new title: ''; yourself]! !

!PGPicture methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:17'!
isPicture
	^ true! !

!PGPicture methodsFor: '*pier-gallery-seaside' stamp: 'damiencassou 11/18/2008 16:32'!
viewComponentClass
	^ PGPictureHtmlView ! !

PRDefaultView subclass: #PGHtmlView
	instanceVariableNames: 'gallery'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Seaside'!

PGHtmlView subclass: #PGGalleryHtmlView
	instanceVariableNames: 'batcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Seaside'!

PGGalleryHtmlView class
	instanceVariableNames: 'gallery'!

PGGalleryHtmlView class
	instanceVariableNames: 'gallery'!

!PGGalleryHtmlView class methodsFor: 'testing' stamp: 'damiencassou 11/18/2008 13:37'!
isAbstract
	^ false! !

!PGGalleryHtmlView methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/19/2008 15:33'!
batcher
	^ batcher ifNil: [batcher := WABatchedList new items: self pictures; batchSize: 10 ]! !

!PGGalleryHtmlView methodsFor: 'as yet unclassified' stamp: 'damiencassou 11/19/2008 15:36'!
children
	^ (Array with: self batcher), (self pictures gather: [:picture | picture componentsIn: self context])! !

!PGGalleryHtmlView methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/19/2008 13:46'!
pictures
	^ self gallery allPicturesIn: self context! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'damiencassou 11/19/2008 15:42'!
renderBatcherOn: html
	(self batcher maxPages = 1)
		ifFalse: [html render: self batcher]! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'damiencassou 11/19/2008 15:43'!
renderContentOn: html
	super renderContentOn: html.
	self renderPictures: self batcher batch on: html.
	self renderBatcherOn: html! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'damiencassou 11/19/2008 15:45'!
renderPicture: aPicture on: html
	html heading: aPicture title.
	self render: aPicture fileStructure on: html.
	self render: aPicture on: html.! !

!PGGalleryHtmlView methodsFor: 'rendering' stamp: 'damiencassou 11/19/2008 15:31'!
renderPictures: pictures on: html
	pictures do: [:picture |
		self renderPicture: picture on: html
		]! !

!PGHtmlView methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/18/2008 16:29'!
gallery
	^ gallery ifNil: [ gallery := self find: PGGallery]! !

PGHtmlView subclass: #PGPictureHtmlView
	instanceVariableNames: 'picture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Gallery-Seaside'!

!PGPictureHtmlView methodsFor: 'accessing-dynamic' stamp: 'damiencassou 11/19/2008 13:55'!
picture
	^ picture ifNil: [picture := self find: PGPicture]! !

!PGPictureHtmlView methodsFor: 'rendering' stamp: 'damiencassou 11/19/2008 15:46'!
renderContentOn: html
	super renderContentOn: html.
	self render: self picture fileStructure on: html! !
